﻿local interruptSpells={
                    -- spellNames
                    {"Rebuke", "Skull Bash", "Skull Bash", "Solar Beam", "Mind Freeze", "Counterspell", "Kick", "Silencing Shot", "Wind Shear", "Spell Lock", "Pummel", "Silence"},
                    -- spellIds
                    {96231, 80964, 80965, 78675, 47528, 2139, 1766, 34490, 57994, 19647, 6552, 15487},
                    -- spellCooldowns
                    {10, 10, 10, 60, 10, 24, 10, 20, 15, 24, 10, 45}
                }
local IMversion = 127

function InterruptManager_SavePosition()
    InterruptManagerAnchor:StopMovingOrSizing()
    for i=1,5 do
        IMDB[1][i] = select(i,InterruptManagerAnchor:GetPoint())
    end
end

--[[    IMDB = {
                [1] = Anchor:GetPoint()
                [2] = Anchor:GetSize()
                [3] = Anchor:GetMovable()
                [4] = Anchor:GetAlpha()
                [5] = Icon:GetPoint(x,y)
                [6] = Icon:GetSize()
                [7] = Icon:GetAlpha()
                [8] = Icon.text:GetFontSize(),Icon.text:GetFontAlpha()
                [9] = StatusBar:GetSize()
                [10]= StatusBar:GetPoint(x,y)
                [11]= StatusBar:GetAlpha()
                [12]= StatusBar.text:GetSize(),StatusBar.text:GetAlpha()
                [13]= SoloMode
                [14]= Version
                [15]= Announce
                [16]= PUGmode
                [17]= TargetWarn
                [18]= FocusWarn
                [19]= AnnounceAfterPUGmodeOff
                }
]]

function InterruptManager_AssignSavedVariables()
    if IMDB then
        if not IMDB[1] then
            IMDB =  {
                    [1] = {"CENTER",nil,"CENTER",0,0},
                    [2] = {180,100},
                    [3] = 1,
                    [4] = 0.2,
                    [5] = {-20,20},
                    [6] = {20,20},
                    [7] = 0.4,
                    [8] = {12,1},
                    [9] = {180,20},
                    [10]= {0,0},
                    [11]= {1},
                    [12]= {12,1}
                    }
        end
        IMDB[13] = 0
        IMDB[14] = IMVersion
        IMDB[15] = 1
        IMDB[16] = 0
        IMDB[17] = 1
        IMDB[18] = 0
        IMDB[19] = 0
        else
        IMDB =  {
                [1] = {"CENTER",nil,"CENTER",0,0},
                [2] = {180,100},
                [3] = 1,
                [4] = 0.2,
                [5] = {-20,20},
                [6] = {20,20},
                [7] = 0.4,
                [8] = {12,1},
                [9] = {180,20},
                [10]= {0,0},
                [11]= {1},
                [12]= {12,1},
                [13]= 0,
                [14]= IMVersion,
                [15]= 1,
                [16]= 0,
                [17]= 1,
                [18]= 0,
                [19]= 0
                }
    end
end

function InterruptManager_VariablesLoaded()
    if not interrupters then
        interrupters =  {[1]={},[2]={},[3]={},[4]={},[5]={}}
        else
        for k,v in pairs(interrupters[2]) do
            if v then
                interrupters[2][k] = GetTime()
            end
        end
    end
    if not IMDB then
        InterruptManager_AssignSavedVariables()
        else
        if IMversion ~= IMDB[14] then
            InterruptManager_AssignSavedVariables()
        end
    end
    local f = CreateFrame("Frame","InterruptManagerAnchor")
    f:SetSize(IMDB[2][1],IMDB[2][2])
    f:SetPoint(IMDB[1][1],IMDB[1][2],IMDB[1][3],IMDB[1][4],IMDB[1][5])
    f:SetParent(UIParent)
    if IMDB[3] == 1 then
        f:SetMovable(IMDB[3])
        f:SetScript("OnMouseDown",function()f:StartMoving()end)
        f:SetScript("OnMouseUp",InterruptManager_SavePosition)
    end
    local t = f:CreateTexture()
    t:SetTexture(0,0,0,IMDB[4])
    t:SetAllPoints(f)
    
    for i = 1,5 do
        local f = CreateFrame("Frame","InterruptManagerIcon"..i)
        f:SetSize(IMDB[6][1],IMDB[6][2])
        f:SetPoint("TOPLEFT","InterruptManagerAnchor","TOPLEFT",IMDB[5][1],-IMDB[5][2]*i+IMDB[5][2])
        f:SetParent(InterruptManagerAnchor)
        local t = f:CreateTexture()
        t:SetAllPoints(f)
        t:SetTexture(0,0,0,IMDB[7])
        t = f:CreateFontString()
        t:SetPoint("CENTER","InterruptManagerIcon"..i,"CENTER")
        t:SetFont("Fonts\\FRIZQT__.TTF", IMDB[8][1])
        t:SetText(i)
        t:SetTextColor(1,1,1,IMDB[8][2])
    
        f = CreateFrame("StatusBar", "InterruptManagerStatusBar"..i)
        f:SetSize(IMDB[9][1],IMDB[9][2])
        f:SetPoint("LEFT","InterruptManagerIcon"..i,"RIGHT",IMDB[10][1],IMDB[10][2])
        f:SetParent(InterruptManagerAnchor)
        f:SetOrientation("HORIZONTAL")
        f:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
        f:SetStatusBarColor(0,1,0,IMDB[11])
        f:SetFrameLevel(2)
        f:SetMinMaxValues(0,1)
        f:SetValue(0)
        t = f:CreateFontString("InterruptManagerStatusBarText"..i)
        t:SetPoint("LEFT","InterruptManagerStatusBar"..i,"LEFT",5,0)
        t:SetFont("Fonts\\FRIZQT__.TTF",IMDB[12][1])
        t:SetTextColor(1,1,1,IMDB[12][2])
        t:SetText(interrupters[1][i])
    end
    local c = CreateFrame("MessageFrame","InterruptManagerText")
    c:SetWidth(300)
    c:SetHeight(40)
    c:SetPoint("CENTER", UIParent, "CENTER", 0, 80)
    c:SetFont("Fonts\\FRIZQT__.TTF", 40)
    c:SetFadeDuration(1)
    c:SetTimeVisible(2)
    InterruptManager_OnLogin()
    f:SetScript("OnUpdate",InterruptManager_OnUpdate)
    RegisterAddonMessagePrefix("InterruptManager")
end

function InterruptManager_OnUpdate()
    for i=1,#interrupters[2] do
        getglobal("InterruptManagerStatusBar"..i):SetValue(interrupters[2][i]-GetTime())
        if interrupters[2][i]-GetTime() > 0 then
            getglobal("InterruptManagerStatusBarText"..i):SetText(interrupters[1][i].." "..round(interrupters[2][i]-GetTime(),2))
            elseif getglobal("InterruptManagerStatusBarText"..i):GetText() ~= interrupters[1][i] then
            getglobal("InterruptManagerStatusBarText"..i):SetText(interrupters[1][i])
        end
    end
end

function InterruptManager_OnEvent(self, event, ...)
    if event == "COMBAT_LOG_EVENT_UNFILTERED" then
         InterruptManager_CombatLogEvent(self, event, ...)
         elseif event == "VARIABLES_LOADED" then
         InterruptManager_VariablesLoaded()
         elseif event == "PARTY_MEMBERS_CHANGED" then
         elseif event == "CHAT_MSG_ADDON" then
         InterruptManager_ChatMsgAddon(self, event, ...)
         elseif event == "CHAT_MSG_SYSTEM" then
         InterruptManager_ChatMsgSystem(self, event, ...)
    end
end

f = CreateFrame("Frame","InterruptManager222")
f:SetScript("OnEvent",InterruptManager_OnEvent)
f:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
f:RegisterEvent("VARIABLES_LOADED")
f:RegisterEvent("PARTY_MEMBERS_CHANGED")
f:RegisterEvent("CHAT_MSG_ADDON")
f:RegisterEvent("CHAT_MSG_SYSTEM")

function InterruptManager_CombatLogEvent(self, event, ...)
    local event = select(2, ...)
    local notInterruptible = select(9, UnitCastingInfo("target"))
    local sourceName = select(5, ...)
    local spellId = select(12, ...)
    local spellName = select(13, ...)
    local cooldown
    if UnitExists("target") and event == "SPELL_CAST_START" and sourceName == UnitName("target") and not notInterruptible and IMDB[17] == 1 then
        if IMDB[13] == 0 then
            for i = 1,5 do
                if select(2,getglobal("InterruptManagerStatusBar"..i):GetPoint()) == InterruptManagerIcon1 then
                    if getglobal("InterruptManagerStatusBarText"..i):GetText() == UnitName("player") then
                        InterruptManagerText:AddMessage("Interrupt now! (target)",0,0,1)
                        PlaySoundFile("Sound\\Interface\\PVPFlagTakenMono.wav")
                    end
                    break
                end
            end
            else
            InterruptManagerText:AddMessage("Interrupt now! (target)",0,0,1)
            PlaySoundFile("Sound\\Interface\\PVPFlagTakenMono.wav")
        end
        elseif UnitExists("focus") and event == "SPELL_CAST_START" and sourceName == UnitName("focus") and not notInterruptible and IMDB[18] == 1 then
        if IMDB[13] == 0 then
            for i = 1,5 do
                if select(2,getglobal("InterruptManagerStatusBar"..i):GetPoint()) == InterruptManagerIcon1 then
                    if getglobal("InterruptManagerStatusBarText"..i):GetText() == UnitName("player") then
                        InterruptManagerText:AddMessage("Interrupt now! (focus)",0.7,0,1)
                        PlaySoundFile("Sound\\Interface\\PVPFlagTakenMono.wav")
                    end
                    break
                end
            end
            else
            InterruptManagerText:AddMessage("Interrupt now! (focus)",0,0,1)
            PlaySoundFile("Sound\\Interface\\PVPFlagTakenMono.wav")
        end
    end
    if event == "SPELL_CAST_SUCCESS" and tContains(interruptSpells[2], spellId) and tContains(interrupters[1], sourceName) then
        for i=1,#interruptSpells[2] do
            if interruptSpells[2][i] == spellId then
                cooldown = interruptSpells[3][i]
            end
        end
        for i=1,#interrupters[1] do
            if interrupters[1][i] == sourceName then
                interrupters[2][i] = GetTime() + cooldown
                getglobal("InterruptManagerStatusBar"..i):SetMinMaxValues(0, cooldown)
            end
        end
        wipe(interrupters[3])
        wipe(interrupters[4])
        for i=1,#interrupters[2] do
            if interrupters[2][i] == 0 then
                interrupters[2][i] = i
            end
            tinsert(interrupters[3],interrupters[2][i])
        end
        sort(interrupters[3])
        for k,v in pairs(interrupters[2]) do
            for a,b in pairs(interrupters[3]) do
                if v == b and not tContains(interrupters[4], a) then
                    interrupters[4][k] = a
                end
            end
        end
        for i=1,#interrupters[2] do
            getglobal("InterruptManagerStatusBar"..i):SetPoint("LEFT",getglobal("InterruptManagerIcon"..interrupters[4][i]),"RIGHT")
        end
        if IMDB[15] == 1 then
            if sourceName == UnitName("player") then
                SendChatMessage("Used "..spellName,"SAY")
            end
            elseif IMDB[16] == 1 then
            for i = 1,5 do
                if select(2,getglobal("InterruptManagerStatusBar"..i):GetPoint()) == InterruptManagerIcon1 then
                    SendChatMessage(sourceName.." used "..spellName..".","SAY")
                    SendChatMessage("Interrupting next: "..getglobal("InterruptManagerStatusBarText"..i):GetText(),"SAY")
                    break
                end
            end
        end
        for i = 1,5 do
            if select(2,getglobal("InterruptManagerStatusBar"..i):GetPoint()) == InterruptManagerIcon1 then
                if getglobal("InterruptManagerStatusBarText"..i):GetText() == UnitName("player") then
                    InterruptManagerText:AddMessage("You are interrupting next!")
                    PlaySoundFile("Sound\\Interface\\PVPFlagCapturedHordeMono.wav")
                end
                break
            end
        end
    end
end

local temp = {"0"}
function InterruptManager_ChatMsgAddon(self, event, ...)
    local prefix,msg,_,sender = ...
    if prefix == "InterruptManager" then
            --[]--
        if strfind(msg,"Version") then
            local v = gsub(msg,"Version","")
            v = tonumber(v)
            if v > IMversion then
                DEFAULT_CHAT_FRAME:AddMessage("InterruptManager version "..(v/100).." is available at www.wow.curse.com! (Currently "..(IMversion/100)..")",1,0.8,0)
            end
            SendAddonMessage("InterruptManager","Confirm","RAID")
            --[]--
            elseif strfind(msg,"Confirm") then
            tinsert(interrupters[5],sender)
            --[]--
            elseif strfind(msg, "IMInterrupter") and sender ~= UnitName("player") then
            if strfind(msg, "IMInterrupter1") then
                temp[1] = gsub(msg, "IMInterrupter1","")
                elseif strfind(msg, "IMInterrupter2") then
                temp[2] = gsub(msg, "IMInterrupter2","")
                elseif strfind(msg, "IMInterrupter3") then
                temp[3] = gsub(msg, "IMInterrupter3","")
                elseif strfind(msg, "IMInterrupter4") then
                temp[4] = gsub(msg, "IMInterrupter4","")
                elseif strfind(msg, "IMInterrupter5") then
                temp[5] = gsub(msg, "IMInterrupter5","")
            end
            if #temp == 5 and tContains(temp, UnitName("player")) then
                if not InterruptManagerConfigEditbox1 then
                    InterruptManager_CreateConfig()
                end
                InterruptManagerConfigEditbox1:SetText(temp[1])
                InterruptManagerConfigEditbox2:SetText(temp[2])
                InterruptManagerConfigEditbox3:SetText(temp[3])
                InterruptManagerConfigEditbox4:SetText(temp[4])
                InterruptManagerConfigEditbox5:SetText(temp[5])
                InterruptManager_OnReceiveInterruptersBroadcast()
                wipe(temp)
            end
            --[]--
            elseif strfind(msg, "PUG1") and sender ~= UnitName("player") and tContains(interrupters[1], sender) then
            IMDB[15] = 0
            IMDB[16] = 0
            InterruptManagerConfigCheckbutton3:SetChecked(0)
            InterruptManagerConfigCheckbutton4:SetChecked(0)
            elseif strfind(msg, "PUG0") and sender ~= UnitName("player") and tContains(interrupters[1], sender) then
            if IMDB[19] == 0 then
                IMDB[15] = 0
                InterruptManagerConfigCheckbutton3:SetChecked(0)
                else
                IMDB[15] = 1
                IMDB[16] = 0
                InterruptManagerConfigCheckbutton3:SetChecked(1)
                InterruptManagerConfigCheckbutton4:SetChecked(0)
            end
        end
    end
end


-- [Function to prevent system message spam] --
ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", function(self, event, msg)
    if(strfind(msg, "No player named ")) then
        return true
    end
end)
local AntiSpam = {{},{}}
function InterruptManager_ChatMsgSystem(self, event, ...)
    local text = ...
    if strfind(text, "No player named ") then
        if not tContains(AntiSpam[1],text) then
            DEFAULT_CHAT_FRAME:AddMessage(text,1,1,0)
            tinsert(AntiSpam[1],text)
            tinsert(AntiSpam[2],GetTime()+1)
            else
            for k,v in pairs(AntiSpam[1]) do
                if v == text then
                    if GetTime() >= AntiSpam[2][k] then
                        AntiSpam[2][k] = GetTime()+1
                        DEFAULT_CHAT_FRAME:AddMessage(text,1,1,0)
                    end
                end
            end
        end
    end
end

SLASH_INTERRUPTMANAGER1 = '/im'
function SlashCmdList.INTERRUPTMANAGER(msg, editbox)
    if string.find(msg, "lock") then
        InterruptManager_OnFrameLock()
        else
        InterruptManager_OpenConfig()
    end
end

function InterruptManager_OpenConfig()
    if not InterruptManagerConfig then
        InterruptManager_CreateConfig()
        InterruptManagerConfig:Show()
        else
        InterruptManagerConfig:Show()
    end
    InterruptManagerAnchor:Show()
    InterruptManagerAnchor:SetHeight(IMDB[2][2])
    for i=1,5 do
        getglobal("InterruptManagerStatusBar"..i):Show()
        getglobal("InterruptManagerIcon"..i):Show()
        if interrupters[1][i] then
            getglobal("InterruptManagerConfigEditbox"..i):SetText(interrupters[1][i])
        end
    end
    SendAddonMessage("InterruptManager","Version"..IMversion,"RAID")
end

function InterruptManager_CreateConfig()
    -- Configuration box
    f = CreateFrame("Frame","InterruptManagerConfig")
    f:SetHeight(460)
    f:SetWidth(300)
    f:SetPoint("CENTER")
    f:SetParent(UIParent)
    f:SetFrameLevel(1)
    f:SetMovable(1)
    f:SetBackdrop({
        bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
        edgeFile = "Interface\\AddOns\\InterruptManager\\Textures\\ConfigBorder",
        tile = true,
        tileSize = 16,
        edgeSize = 16,
        insets = {left = 5,right = 5,top = 5,bottom = 5}
    })
    
    -- Configuration box title
    f = CreateFrame("Frame")
    f:SetHeight(30)
    f:SetWidth(200)
    f:SetPoint("CENTER","InterruptManagerConfig","TOP",0,-15)
    f:SetParent(InterruptManagerConfig)
    f:SetScript("OnMouseDown",function()InterruptManagerConfig:StartMoving()end)
    f:SetScript("OnMouseUp",function()InterruptManagerConfig:StopMovingOrSizing()end)
    f:SetBackdrop({
        bgFile = "Interface\\DialogFrame\\UI-DialogBox-Backgroun",
        edgeFile = "Interface\\AddOns\\Prodigo\\Textures\\ConfigBorder",
        tile = true,
        tileSize = 16,
        edgeSize = 16,
        insets = {left = 5,right = 5,top = 5,bottom = 5}
    })
    t = f:CreateFontString()
    t:SetPoint("CENTER",f,"CENTER",0,0)
    t:SetFont("Fonts\\FRIZQT__.TTF",12)
    t:SetText("Interrupt Manager")
    
    local moveAll = 30
    -- Close button
    InterruptManager_CreateConfigButton("Close",80,0,-230+moveAll,InterruptManager_OnCloseClick)
    -- Reset button
    InterruptManager_CreateConfigButton("Reset",80,0,0+moveAll,InterruptManager_Reset)
    -- Editboxes
    InterruptManager_CreateConfigEditbox("First Interrupter",0,150+moveAll)
    InterruptManager_CreateConfigEditbox("Second Interrupter",0,120+moveAll)
    InterruptManager_CreateConfigEditbox("Third Interrupter",0,90+moveAll)
    InterruptManager_CreateConfigEditbox("Fourth Interrupter",0,60+moveAll)
    InterruptManager_CreateConfigEditbox("Fifth Interrupter",0,30+moveAll)
    -- Fill in name buttons
    InterruptManager_CreateConfigButton("1",20,-115,150+moveAll,function() InterruptManager_FillInName(1) end)
    InterruptManager_CreateConfigButton("2",20,-115,120+moveAll,function() InterruptManager_FillInName(2) end)
    InterruptManager_CreateConfigButton("3",20,-115,90+moveAll,function() InterruptManager_FillInName(3) end)
    InterruptManager_CreateConfigButton("4",20,-115,60+moveAll,function() InterruptManager_FillInName(4) end)
    InterruptManager_CreateConfigButton("5",20,-115,30+moveAll,function() InterruptManager_FillInName(5) end)
    -- Checkboxes
    InterruptManager_CreateConfigCheckbutton("Lock bars",-80,-30+moveAll,"Turn on to lock bars",1-IMDB[3],InterruptManager_OnFrameLock)
    InterruptManager_CreateConfigCheckbutton("Solo mode",-80,-60+moveAll,"Turn on to be warned when your target/focus is casting, regardless of your position in the queue",IMDB[13],InterruptManager_OnSoloModeToggle)
    InterruptManager_CreateConfigCheckbutton("Announce",-80,-90+moveAll,"Turn on to announce your interrupts",IMDB[15],InterruptManager_OnAnnounceToggle)
    InterruptManager_CreateConfigCheckbutton("PUG mode",-80,-120+moveAll,"Turn on if someone is missing the addon",IMDB[16],InterruptManager_OnPUGModeToggle)
    InterruptManager_CreateConfigCheckbutton("Watch target",-80,-150+moveAll,"Turn on to be warned when your target casts a spell",IMDB[17],InterruptManager_OnTargetWatchToggle)
    InterruptManager_CreateConfigCheckbutton("Watch focus ",-80,-180+moveAll,"Turn on to be warned when your focus casts a spell",IMDB[18],InterruptManager_OnFocusWatchToggle)
    InterruptManagerConfig:Hide()
end

function InterruptManager_CreateConfigCheckbutton(text,x,y,tooltip,checked,script)
    for i=1,100 do
        if not getglobal("InterruptManagerConfigCheckbutton"..i) then
            f = CreateFrame("CheckButton","InterruptManagerConfigCheckbutton"..i,InterruptManagerConfig,"ChatConfigCheckButtonTemplate")
            f:SetSize(20,20)
            f:SetPoint("CENTER","InterruptManagerConfig","CENTER",x,y)
            f:SetFrameLevel(2)
            f:SetScript("OnClick",script)
            f:SetChecked(checked)
            f:SetNormalTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigCheckboxUp")
            f:SetPushedTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigCheckboxDown")
            f:SetHighlightTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonHighlight",0)
            f:SetCheckedTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigCheckboxChecked")
            f:SetDisabledTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonDisabled")
            f.tooltip = tooltip
            t = f:CreateFontString("InterruptManagerConfigCheckButton"..i.."Text")
            t:SetPoint("LEFT","InterruptManagerConfigCheckbutton"..i,"LEFT",25,0)
            t:SetFont("Fonts\\FRIZQT__.TTF",12)
            t:SetText(text)
            break
        end
    end
end

function InterruptManager_CreateConfigEditbox(text,x,y)
    for i=1,100 do
        if not getglobal("InterruptManagerConfigEditbox"..i) then
            f = CreateFrame("Editbox","InterruptManagerConfigEditbox"..i)
            f:SetSize(200,30)
            f:SetParent(InterruptManagerConfig)
            f:SetPoint("CENTER","InterruptManagerConfig","CENTER",x,y)
            f:SetFrameLevel(2)
            f:SetBackdrop({
                bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
                edgeFile = "Interface\\AddOns\\InterruptManager\\Textures\\ConfigBorder",
                tile = true,
                tileSize = 16,
                edgeSize = 16,
                insets = {left = 5,right = 5,top = 5,bottom = 5}
            })
            f:SetAutoFocus(false)
            f:ClearFocus()
            f:SetFont("Fonts\\FRIZQT__.TTF",12)
            f:Insert(text)
            f:SetMaxLetters(20)
            f:SetTextInsets(9,0,0,0)
            f:SetScript("OnEscapePressed",function()getglobal("InterruptManagerConfigEditbox"..i):ClearFocus()end)
            f:SetScript("OnEnterPressed",function()getglobal("InterruptManagerConfigEditbox"..i):ClearFocus()end)
            f:SetScript("OnTabPressed",InterruptManager_EditboxOnTabPressed)
            f:SetScript("OnEditFocusGained",function()getglobal("InterruptManagerConfigEditbox"..i):HighlightText()end)
            f:SetScript("OnEditFocusLost",function()getglobal("InterruptManagerConfigEditbox"..i):HighlightText(0,0)end)
            break
        end
    end
end

function InterruptManager_EditboxOnTabPressed()
    for i=1,5 do
        f = getglobal("InterruptManagerConfigEditbox"..i)
        if f then
            if f:HasFocus() then
                if i < 5 then
                    getglobal("InterruptManagerConfigEditbox"..i+1):SetFocus()
                    break
                    else
                    InterruptManagerConfigEditbox1:SetFocus()
                    break
                end
            end
        end
    end
end

function InterruptManager_CreateConfigButton(text,width,x,y,script,tooltip)
    for i=1,100 do
        if not getglobal("InterruptManagerConfigButton"..i) then
            f = CreateFrame("Button","InterruptManagerConfigButton"..i)
            f:SetScript("OnClick",script)
            f:SetHeight(20)
            f:SetWidth(width)
            f:SetParent(InterruptManagerConfig)
            f:SetPoint("CENTER","InterruptManagerConfig","CENTER",x,y)
            f:SetFrameLevel(2)
            f:SetNormalTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonUp")
            f:SetPushedTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonDown")
            f:SetHighlightTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonHighlight",0)
            f:SetDisabledTexture("Interface\\AddOns\\InterruptManager\\Textures\\ConfigButtonDisabled")
            f.tooltip = tooltip
            
            local font = f:CreateFontString()
            f:SetFontString(font)
            f:SetPushedTextOffset(-1,-1)
            font:SetFont("Fonts\\FRIZQT__.TTF",12)
            font:SetText(text)
            font:SetTextColor(0,0,0)
            break
        end
    end
end

function InterruptManager_FillInName(index)
    if UnitExists("target") then
        local name, realm = UnitName("target")
        if realm then
            getglobal("InterruptManagerConfigEditbox"..index):SetText(name.."-"..realm)
            else
            getglobal("InterruptManagerConfigEditbox"..index):SetText(name)
        end
    end
end

function InterruptManager_OnLogin()
    InterruptManagerAnchor:Hide()
    for i=1,5 do
        if interrupters and interrupters[1] and interrupters[1][i] then
            getglobal("InterruptManagerStatusBar"..i):Show()
            getglobal("InterruptManagerIcon"..i):Show()
            InterruptManagerAnchor:Show()
            InterruptManagerAnchor:SetHeight(IMDB[2][2]*i*0.2)
            else
            getglobal("InterruptManagerStatusBar"..i):Hide()
            getglobal("InterruptManagerIcon"..i):Hide()
        end
    end
end

function InterruptManager_Reset()
    InterruptManagerConfigEditbox1:SetText("First Interrupter")
    InterruptManagerConfigEditbox2:SetText("Second Interrupter")
    InterruptManagerConfigEditbox3:SetText("Third Interrupter")
    InterruptManagerConfigEditbox4:SetText("Fourth Interrupter")
    InterruptManagerConfigEditbox5:SetText("Fifth Interrupter")
    wipe(interrupters[1])
    wipe(interrupters[2])
    wipe(interrupters[3])
    wipe(interrupters[4])
    
    for i=1,5 do
        getglobal("InterruptManagerStatusBarText"..i):SetText("")
        getglobal("InterruptManagerStatusBar"..i):SetPoint("LEFT",getglobal("InterruptManagerIcon"..i),"RIGHT")
        getglobal("InterruptManagerStatusBar"..i):SetValue(0)
    end
end

function InterruptManager_OnFrameLock()
    if IMDB[3] == 1 then
        IMDB[3] = 0
        ChatFrame1:AddMessage("InterruptManager: Frame locked.",1,0.5,0)
        InterruptManagerConfigCheckbutton1:SetChecked(1)
        InterruptManagerAnchor:SetMovable(false)
        InterruptManagerAnchor:EnableMouse(false)
        InterruptManagerAnchor:SetScript("OnMouseDown",nil)
        InterruptManagerAnchor:SetScript("OnMouseUp",nil)
        else
        IMDB[3] = 1
        InterruptManagerConfigCheckbutton1:SetChecked(0)
        ChatFrame1:AddMessage("InterruptManager: Frame unlocked.",1,0.5,0)
        InterruptManagerAnchor:SetMovable(true)
        InterruptManagerAnchor:EnableMouse(true)
        InterruptManagerAnchor:SetScript("OnMouseDown",function()InterruptManagerAnchor:StartMoving()end)
        InterruptManagerAnchor:SetScript("OnMouseUp",InterruptManager_SavePosition)
    end
end

function InterruptManager_OnSoloModeToggle()
    if IMDB[13] == 1 then
        IMDB[13] = 0
        ChatFrame1:AddMessage("InterruptManager: Solo mode disabled.",1,0.5,0)
        else
        IMDB[13] = 1
        ChatFrame1:AddMessage("InterruptManager: Solo mode enabled. You will now be warned when your target/focus starts casting a spell, regardless of your position in the queue.",1,0.5,0)
    end
end

function InterruptManager_OnAnnounceToggle()
    if IMDB[15] == 0 then
        IMDB[15] = 1
        IMDB[19] = 1
        IMDB[16] = 0
        InterruptManagerConfigCheckbutton4:SetChecked(0)
        ChatFrame1:AddMessage("InterruptManager: Announce enabled.",1,0.5,0)
        else
        IMDB[15] = 0
        IMDB[19] = 0
        ChatFrame1:AddMessage("InterruptManager: Announce disabled.",1,0.5,0)
    end
end

function InterruptManager_OnPUGModeToggle()
    if IMDB[16] == 0 then
        IMDB[16] = 1
        IMDB[15] = 0
        InterruptManagerConfigCheckbutton3:SetChecked(0)
        ChatFrame1:AddMessage("InterruptManager: PUG mode enabled. You will now announce when someone uses their interrupt ability, and whose turn it is next.",1,0.5,0)
        SendAddonMessage("InterruptManager","PUG1","RAID")
        else
        IMDB[16] = 0
        ChatFrame1:AddMessage("InterruptManager: PUG mode disabled.",1,0.5,0)
        SendAddonMessage("InterruptManager","PUG0","RAID")
    end
end

function InterruptManager_OnTargetWatchToggle()
    if IMDB[17] == 0 then
        IMDB[17] = 1
        ChatFrame1:AddMessage("InterruptManager: You will now be warned when your target starts casting a spell.",1,0.5,0)
        else
        IMDB[17] = 0
        ChatFrame1:AddMessage("InterruptManager: You will no longer be warned when your target starts casting a spell.",1,0.5,0)
    end
end

function InterruptManager_OnFocusWatchToggle()
    if IMDB[18] == 0 then
        IMDB[18] = 1
        ChatFrame1:AddMessage("InterruptManager: You will now be warned when your focus starts casting a spell.",1,0.5,0)
        else
        IMDB[18] = 0
        ChatFrame1:AddMessage("InterruptManager: You will no longer be warned when your focus starts casting a spell.",1,0.5,0)
    end
end

function InterruptManager_BroadcastInterrupters()
    if GetNumPartyMembers() > 0 or GetNumRaidMembers() > 0 then
        for i = 1,5 do
            local text2 = getglobal("InterruptManagerConfigEditbox"..i):GetText()
            SendAddonMessage("InterruptManager","IMInterrupter"..i..text2,"RAID")
        end
    end
end

function InterruptManager_OnCloseClick()
    InterruptManagerConfig:Hide()
    wipe(interrupters[1])
    wipe(interrupters[2])
    wipe(interrupters[3])
    wipe(interrupters[4])
    InterruptManagerAnchor:SetHeight(0)
    pugMode = 0
    for i=1,5 do
        getglobal("InterruptManagerStatusBar"..i):SetPoint("LEFT",getglobal("InterruptManagerIcon"..i),"RIGHT")
        InterruptManagerAnchor:Hide()
        getglobal("InterruptManagerStatusBar"..i):Hide()
        getglobal("InterruptManagerIcon"..i):Hide()
    end
    for i=1,5 do
        local text = getglobal("InterruptManagerConfigEditbox"..i):GetText()
        if text ~= "" and not strfind(text," Interrupter") then
            InterruptManagerAnchor:SetHeight(0.2*i*IMDB[2][2])
            InterruptManagerAnchor:Show()
            getglobal("InterruptManagerStatusBar"..i):Show()
            getglobal("InterruptManagerIcon"..i):Show()
            tinsert(interrupters[1],text)
            tinsert(interrupters[2],0)
            tinsert(interrupters[3],0)
            tinsert(interrupters[4],0)
        end
    end
    InterruptManager_BroadcastInterrupters()
end

function InterruptManager_OnReceiveInterruptersBroadcast()
    wipe(interrupters[1])
    wipe(interrupters[2])
    wipe(interrupters[3])
    wipe(interrupters[4])
    InterruptManagerAnchor:SetHeight(0)
    pugMode = 0
    for i=1,5 do
        getglobal("InterruptManagerStatusBar"..i):SetPoint("LEFT",getglobal("InterruptManagerIcon"..i),"RIGHT")
        InterruptManagerAnchor:Hide()
        getglobal("InterruptManagerStatusBar"..i):Hide()
        getglobal("InterruptManagerIcon"..i):Hide()
    end
    for i=1,5 do
        local text = getglobal("InterruptManagerConfigEditbox"..i):GetText()
        if text ~= "" and not strfind(text," Interrupter") then
            InterruptManagerAnchor:SetHeight(0.2*i*IMDB[2][2])
            InterruptManagerAnchor:Show()
            getglobal("InterruptManagerStatusBar"..i):Show()
            getglobal("InterruptManagerIcon"..i):Show()
            tinsert(interrupters[1],text)
            tinsert(interrupters[2],0)
            tinsert(interrupters[3],0)
            tinsert(interrupters[4],0)
        end
    end
end

function Test2()
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end